% This script assembles the stiffness matrix and vector 
% of the myofibroblasts.

S_m = sparse(n,n);
F_m = zeros(n,1);
for i = 1:(n-1)
    clear Selem
    clear Felem
	h = x(i+1)-x(i);
    
    f_1 = 0; f_2 = 0;
    if M(i)~=0
        f_1 = (1+r_F_max)*c(i)*(1-kappa_F*(N(i)+M(i)))*M(i)^q/...
            (a_c_I+c(i));
    end
    if M(i+1)~=0
        f_2 = (1+r_F_max)*c(i+1)*(1-kappa_F*(N(i+1)+M(i+1)))*...
            M(i+1)^q/(a_c_I+c(i+1));
    end
    
    c_1 = (c(i+1)-c(i))/h; c_2 = 0;
    if i~=n-1
        c_2 = (c(i+2)-c(i+1))/(x(i+2)-x(i+1));
    end
    
    A = N(i)+M(i)+N(i+1)+M(i+1);
    
    Selem = A*D_F/(2*h)*[1,-1;-1,1] ...
        - chi_F/2*[-c_1,-c_2;c_1,c_2] ...
        - r_F*h/2*[f_1,0;0,f_2] ...
        + delta_M*h/6*[2,1;1,2];
    
    Felem = k_F*h/2*[c(i)*N(i);c(i+1)*N(i+1)];
            
    for ind1 = 1:topology
        for ind2 = 1:topology
            S_m(elmat(i,ind1),elmat(i,ind2))= Selem(ind1,ind2) + ...
                S_m(elmat(i,ind1),elmat(i,ind2));
        end
    end
    
    for ind1 = 1:topology
        F_m(elmat(i,ind1)) = F_m(elmat(i,ind1)) + Felem(ind1);
    end
end